/*
 * Este cdigo ***deve*** funcionar no GCC para demonstrar acesso direto  vtable.
 *
 * No h requisito ou padro algum para onde o vptr ou a vtable devem estar localizados.
 * O cdigo abaixo explora o fato de que para herana simples o GCC localiza o vptr logo
 * no incio do objeto.
 *
 *  possvel visualizar o layout do objeto gerado utilizando a opo -fdump-class-hierarchy
 */


#include <iostream>

using namespace std;

class Base
{
public:
    Base() { }
    virtual void f() = 0;
    virtual void g() = 0;
    void chama_f() { f(); }
};

class Derivada : public Base
{
public:
    unsigned int X;
    Derivada() { X = 0x0B4DC0D3; }
    void f() { cout << "F" << endl; }
    void g() { cout << "G" << endl; }
    virtual void h() { cout << "G" << endl; }
};

int main()
{
    Derivada d;

    void ***obj = (void***)&d;
    void **vtable = *obj;

    // imprime o endereo do objeto "d" e seu tamanho
    cout << "endereco d: " << static_cast<void*>(&d) << endl;
    cout << "size: " << sizeof(d) << endl;

    cout << endl;

    // imprime o ponteiro da vtable (vptr)
    cout << "vtable: " << vtable << endl;

    cout << endl;

    // imprime os contedos da vtable (3 funes virtuais)
    cout << "vtable[0]: " << vtable[0] << endl;
    cout << "vtable[1]: " << vtable[1] << endl;
    cout << "vtable[2]: " << vtable[2] << endl;

    cout << endl;

    // o GCC ir emitir um warning (-Wpmf-conversions) para o cdigo abaixo,
    // isso  esperado.
    // Na prtica, gerenciar manualmente ponteiros para funes membros 
    // uma pssima idia j que  perdida a informao dos ponteiros "this"
    // e neste caso tambm de "vptr".

    // imprime os endereos das funes "f", "g" e "h".
    cout << "endereco f: " << reinterpret_cast<void*>(&Derivada::f) << endl;
    cout << "endereco g: " << reinterpret_cast<void*>(&Derivada::g) << endl;
    cout << "endereco h: " << reinterpret_cast<void*>(&Derivada::h) << endl;


    return 0;
}
